package com.hh.arome.common.deviceui;

import android.app.Activity;

public interface IDeviceUI {

    // 显示通知栏
    void showNotification(Activity activity);

    // 隐藏通知栏
    void hideNotification(Activity activity);

    // 显示导航栏
    void showNavigationBar(Activity activity);

    // 隐藏导航栏
    void hideNavigationBar(Activity activity);

    // 打开补光灯
    void showFillLight(Activity activity);

    // 关闭补光灯
    void hideFillLight(Activity activity);

    // 重启设备
    void reboot();


}




